//=============================================================================
// LogchangestateWait.js
//=============================================================================

/*:ja
 * @plugindesc ver1.01 ステート付加・解除時にバトルログでウェイトを入れます。
 * @author まっつＵＰ
 * 
 * @param death
 * @desc 戦闘不能ステート付加・解除時の
 * バトルログのウェイト
 * @type number
 * @max 300
 * @default 16
 * 
 * @param abnormal
 * @desc 戦闘不能以外のステート付加・解除時の
 * バトルログのウェイト
 * @type number
 * @max 300
 * @default 16
 *
 * @help
 * 
 * RPGで笑顔を・・・
 * 
 * このヘルプをよくお読みになってからお使いください。
 * 
 * パラメータのウェイトは
 * 60で60フレームウェイトするということです。
 * 
 * このプラグインを利用する場合は
 * 素材のみの販売はダメです。
 * 上記以外の規約等はございません。
 * もちろんツクールMVで使用する前提です。
 * 何か不具合ありましたら気軽にどうぞ。
 * 
 * ver1.01 パラメータの追加、コードの大幅な変更
 *  
 * 免責事項：
 * このプラグインを利用したことによるいかなる損害も制作者は一切の責任を負いません。
 * 
 */

(function() {

var parameters = PluginManager.parameters('LogchangestateWait');
var LWdeath = parameters['death'];
var LWabnormal = parameters['abnormal'];

Window_BattleLog.prototype.displayAddedStates = function(target) {
    target.result().addedStateObjects().forEach(function(state) {
        var stateMsg = target.isActor() ? state.message1 : state.message2;
        if (state.id === target.deathStateId()) {
            this.push('LogLWstatewait', LWdeath);
            this.push('performCollapse', target);
        }else{
            this.push('LogLWstatewait', LWabnormal);
        }
        if (stateMsg) {
            this.push('popBaseLine');
            this.push('pushBaseLine');
            this.push('addText', target.name() + stateMsg);
            this.push('waitForEffect');
        }
    }, this);
};

Window_BattleLog.prototype.displayRemovedStates = function(target) {
    target.result().removedStateObjects().forEach(function(state) {
        if (state.id === target.deathStateId()) {
            this.push('LogLWstatewait', LWdeath);
        }else{
            this.push('LogLWstatewait', LWabnormal);
        }
        if (state.message4) {
            this.push('popBaseLine');
            this.push('pushBaseLine');
            this.push('addText', target.name() + state.message4);
        }
    }, this);
};

Window_BattleLog.prototype.LogLWstatewait = function(count) {
    this._waitCount = count;
};

})();
